#include "textScreen.h"
#include "common.h"
#include "palette.h"

// private
const word codePage437[256][8] =
{
    {   // ASCII 000
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 001
        0b0011111111111100,
        0b1100000000000011,
        0b1100110000110011,
        0b1100000000000011,
        0b1100111111110011,
        0b1100001111000011,
        0b1100000000000011,
        0b0011111111111100
    },
    {   // ASCII 002
        0b0011111111111100,
        0b1111111111111111,
        0b1111001111001111,
        0b1111111111111111,
        0b1111000000001111,
        0b1111110000111111,
        0b1111111111111111,
        0b0011111111111100
    },
    {   // ASCII 003
        0b0011110011110000,
        0b1111111111111100,
        0b1111111111111100,
        0b1111111111111100,
        0b0011111111110000,
        0b0000111111000000,
        0b0000001100000000,
        0b0000000000000000
    },
    {   // ASCII 004
        0b0000001100000000,
        0b0000111111000000,
        0b0011111111110000,
        0b1111111111111100,
        0b0011111111110000,
        0b0000111111000000,
        0b0000001100000000,
        0b0000000000000000
    },
    {   // ASCII 005
        0b0000111111000000,
        0b0011111111110000,
        0b0000111111000000,
        0b1111111111111100,
        0b1111111111111100,
        0b1111001100111100,
        0b0000001100000000,
        0b0000111111000000
    },
    {   // ASCII 006
        0b0000001100000000,
        0b0000001100000000,
        0b0000111111000000,
        0b0011111111110000,
        0b1111111111111100,
        0b0011111111110000,
        0b0000001100000000,
        0b0000111111000000
    },
    {   // ASCII 007
        0b0000000000000000,
        0b0000000000000000,
        0b0000001111000000,
        0b0000111111110000,
        0b0000111111110000,
        0b0000001111000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 008
        0b1111111111111111,
        0b1111111111111111,
        0b1111110000111111,
        0b1111000000001111,
        0b1111000000001111,
        0b1111110000111111,
        0b1111111111111111,
        0b1111111111111111
    },
    {   // ASCII 009
        0b0000000000000000,
        0b0000111111110000,
        0b0011110000111100,
        0b0011000000001100,
        0b0011000000001100,
        0b0011110000111100,
        0b0000111111110000,
        0b0000000000000000
    },
    {   // ASCII 010
        0b1111111111111111,
        0b1111000000001111,
        0b1100001111000011,
        0b1100111111110011,
        0b1100111111110011,
        0b1100001111000011,
        0b1111000000001111,
        0b1111111111111111
    },
    {   // ASCII 011
        0b0000000011111111,
        0b0000000000111111,
        0b0000000011111111,
        0b0011111111110011,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000
    },
    {   // ASCII 012
        0b0000111111110000,
        0b0011110000111100,
        0b0011110000111100,
        0b0011110000111100,
        0b0000111111110000,
        0b0000001111000000,
        0b0011111111111100,
        0b0000001111000000
    },
    {   // ASCII 013
        0b0000111111111111,
        0b0000111100001111,
        0b0000111111111111,
        0b0000111100000000,
        0b0000111100000000,
        0b0011111100000000,
        0b1111111100000000,
        0b1111110000000000
    },
    {   // ASCII 014
        0b0011111111111111,
        0b0011110000001111,
        0b0011111111111111,
        0b0011110000001111,
        0b0011110000001111,
        0b0011110000111111,
        0b1111110000111100,
        0b1111000000000000
    },
    {   // ASCII 015
        0b0000001111000000,
        0b1111001111001111,
        0b0000111111110000,
        0b1111110000111111,
        0b1111110000111111,
        0b0000111111110000,
        0b1111001111001111,
        0b0000001111000000
    },
    {   // ASCII 016
        0b1100000000000000,
        0b1111110000000000,
        0b1111111111000000,
        0b1111111111111100,
        0b1111111111000000,
        0b1111110000000000,
        0b1100000000000000,
        0b0000000000000000
    },
    {   // ASCII 017
        0b0000000000001100,
        0b0000000011111100,
        0b0000111111111100,
        0b1111111111111100,
        0b0000111111111100,
        0b0000000011111100,
        0b0000000000001100,
        0b0000000000000000
    },
    {   // ASCII 018
        0b0000001111000000,
        0b0000111111110000,
        0b0011111111111100,
        0b0000001111000000,
        0b0000001111000000,
        0b0011111111111100,
        0b0000111111110000,
        0b0000001111000000
    },
    {   // ASCII 019
        0b0011110000111100,
        0b0011110000111100,
        0b0011110000111100,
        0b0011110000111100,
        0b0011110000111100,
        0b0000000000000000,
        0b0011110000111100,
        0b0000000000000000
    },
    {   // ASCII 020
        0b0011111111111111,
        0b1111001111001111,
        0b1111001111001111,
        0b0011111111001111,
        0b0000001111001111,
        0b0000001111001111,
        0b0000001111001111,
        0b0000000000000000
    },
    {   // ASCII 021
        0b0000111111111100,
        0b0011110000001111,
        0b0000111111000000,
        0b0011110011110000,
        0b0011110011110000,
        0b0000111111000000,
        0b1111000011110000,
        0b0011111111000000
    },
    {   // ASCII 022
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111111100,
        0b0011111111111100,
        0b0011111111111100,
        0b0000000000000000
    },
    {   // ASCII 023
        0b0000001111000000,
        0b0000111111110000,
        0b0011111111111100,
        0b0000001111000000,
        0b0011111111111100,
        0b0000111111110000,
        0b0000001111000000,
        0b1111111111111111
    },
    {   // ASCII 024
        0b0000001111000000,
        0b0000111111110000,
        0b0011111111111100,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000000000000000
    },
    {   // ASCII 025
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0011111111111100,
        0b0000111111110000,
        0b0000001111000000,
        0b0000000000000000
    },
    {   // ASCII 026
        0b0000000000000000,
        0b0000001111000000,
        0b0000000011110000,
        0b1111111111111100,
        0b0000000011110000,
        0b0000001111000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 027
        0b0000000000000000,
        0b0000111100000000,
        0b0011110000000000,
        0b1111111111111100,
        0b0011110000000000,
        0b0000111100000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 028
        0b0000000000000000,
        0b0000000000000000,
        0b1111000000000000,
        0b1111000000000000,
        0b1111000000000000,
        0b1111111111111100,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 029
        0b0000000000000000,
        0b0000110000110000,
        0b0011110000111100,
        0b1111111111111111,
        0b0011110000111100,
        0b0000110000110000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 030
        0b0000000000000000,
        0b0000001111000000,
        0b0000111111110000,
        0b0011111111111100,
        0b1111111111111111,
        0b1111111111111111,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 031
        0b0000000000000000,
        0b1111111111111111,
        0b1111111111111111,
        0b0011111111111100,
        0b0000111111110000,
        0b0000001111000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 032
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 033
        0b0000111100000000,
        0b0011111111000000,
        0b0011111111000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000,
        0b0000111100000000,
        0b0000000000000000
    },
    {   // ASCII 034
        0b0011110011110000,
        0b0011110011110000,
        0b0011110011110000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 035
        0b0011110011110000,
        0b0011110011110000,
        0b1111111111111100,
        0b0011110011110000,
        0b1111111111111100,
        0b0011110011110000,
        0b0011110011110000,
        0b0000000000000000
    },
    {   // ASCII 036
        0b0000111100000000,
        0b0011111111110000,
        0b1111000000000000,
        0b0011111111000000,
        0b0000000011110000,
        0b1111111111000000,
        0b0000111100000000,
        0b0000000000000000
    },
    {   // ASCII 037
        0b0000000000000000,
        0b1111000000111100,
        0b1111000011110000,
        0b0000001111000000,
        0b0000111100000000,
        0b0011110000111100,
        0b1111000000111100,
        0b0000000000000000
    },
    {   // ASCII 038
        0b0000111111000000,
        0b0011110011110000,
        0b0000111111000000,
        0b0011111100111100,
        0b1111001111110000,
        0b1111000011110000,
        0b0011111100111100,
        0b0000000000000000
    },
    {   // ASCII 039
        0b0011110000000000,
        0b0011110000000000,
        0b1111000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 040
        0b0000001111000000,
        0b0000111100000000,
        0b0011110000000000,
        0b0011110000000000,
        0b0011110000000000,
        0b0000111100000000,
        0b0000001111000000,
        0b0000000000000000
    },
    {   // ASCII 041
        0b0011110000000000,
        0b0000111100000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000111100000000,
        0b0011110000000000,
        0b0000000000000000
    },
    {   // ASCII 042
        0b0000000000000000,
        0b0011110000111100,
        0b0000111111110000,
        0b1111111111111111,
        0b0000111111110000,
        0b0011110000111100,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 043
        0b0000000000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b1111111111110000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 044
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011110000000000
    },
    {   // ASCII 045
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 046
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000
    },
    {   // ASCII 047
        0b0000000000111100,
        0b0000000011110000,
        0b0000001111000000,
        0b0000111100000000,
        0b0011110000000000,
        0b1111000000000000,
        0b1100000000000000,
        0b0000000000000000
    },
    {   // ASCII 048
        0b0011111111110000,
        0b1111000000111100,
        0b1111000011111100,
        0b1111001111111100,
        0b1111111100111100,
        0b1111110000111100,
        0b0011111111110000,
        0b0000000000000000
    },
    {   // ASCII 049
        0b0000111100000000,
        0b0011111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 050
        0b0011111111000000,
        0b1111000011110000,
        0b0000000011110000,
        0b0000111111000000,
        0b0011110000000000,
        0b1111000011110000,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 051
        0b0011111111000000,
        0b1111000011110000,
        0b0000000011110000,
        0b0000111111000000,
        0b0000000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 052
        0b0000001111110000,
        0b0000111111110000,
        0b0011110011110000,
        0b1111000011110000,
        0b1111111111111100,
        0b0000000011110000,
        0b0000001111111100,
        0b0000000000000000
    },
    {   // ASCII 053
        0b1111111111110000,
        0b1111000000000000,
        0b1111111111000000,
        0b0000000011110000,
        0b0000000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 054
        0b0000111111000000,
        0b0011110000000000,
        0b1111000000000000,
        0b1111111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 055
        0b1111111111110000,
        0b1111000011110000,
        0b0000000011110000,
        0b0000001111000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000
    },
    {   // ASCII 056
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 057
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111110000,
        0b0000000011110000,
        0b0000001111000000,
        0b0011111100000000,
        0b0000000000000000
    },
    {   // ASCII 058
        0b0000000000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000
    },
    {   // ASCII 059
        0b0000000000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011110000000000
    },
    {   // ASCII 060
        0b0000001111000000,
        0b0000111100000000,
        0b0011110000000000,
        0b1111000000000000,
        0b0011110000000000,
        0b0000111100000000,
        0b0000001111000000,
        0b0000000000000000
    },
    {   // ASCII 061
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 062
        0b0011110000000000,
        0b0000111100000000,
        0b0000001111000000,
        0b0000000011110000,
        0b0000001111000000,
        0b0000111100000000,
        0b0011110000000000,
        0b0000000000000000
    },
    {   // ASCII 063
        0b0011111111000000,
        0b1111000011110000,
        0b0000000011110000,
        0b0000001111000000,
        0b0000111100000000,
        0b0000000000000000,
        0b0000111100000000,
        0b0000000000000000
    },
    {   // ASCII 064
        0b0011111111110000,
        0b1111000000111100,
        0b1111001111111100,
        0b1111001111111100,
        0b1111001111111100,
        0b1111000000000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 065 
        0b0000111100000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111111111110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0000000000000000
    },
    {   // ASCII 066
        0b1111111111110000,
        0b0011110000111100,
        0b0011110000111100,
        0b0011111111110000,
        0b0011110000111100,
        0b0011110000111100,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 067
        0b0000111111110000,
        0b0011110000111100,
        0b1111000000000000,
        0b1111000000000000,
        0b1111000000000000,
        0b0011110000111100,
        0b0000111111110000,
        0b0000000000000000
    },
    {   // ASCII 068
        0b1111111111000000,
        0b0011110011110000,
        0b0011110000111100,
        0b0011110000111100,
        0b0011110000111100,
        0b0011110011110000,
        0b1111111111000000,
        0b0000000000000000
    },
    {   // ASCII 069
        0b1111111111111100,
        0b0011110000001100,
        0b0011110011000000,
        0b0011111111000000,
        0b0011110011000000,
        0b0011110000001100,
        0b1111111111111100,
        0b0000000000000000
    },
    {   // ASCII 070
        0b1111111111111100,
        0b0011110000001100,
        0b0011110011000000,
        0b0011111111000000,
        0b0011110011000000,
        0b0011110000000000,
        0b1111111100000000,
        0b0000000000000000
    },
    {   // ASCII 071
        0b0000111111110000,
        0b0011110000111100,
        0b1111000000000000,
        0b1111000000000000,
        0b1111000011111100,
        0b0011110000111100,
        0b0000111111111100,
        0b0000000000000000
    },
    {   // ASCII 072
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111111111110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0000000000000000
    },
    {   // ASCII 073
        0b0011111111000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 074
        0b0000001111111100,
        0b0000000011110000,
        0b0000000011110000,
        0b0000000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 075
        0b1111110000111100,
        0b0011110000111100,
        0b0011110011110000,
        0b0011111111000000,
        0b0011110011110000,
        0b0011110000111100,
        0b1111110000111100,
        0b0000000000000000
    },
    {   // ASCII 076
        0b1111111100000000,
        0b0011110000000000,
        0b0011110000000000,
        0b0011110000000000,
        0b0011110000001100,
        0b0011110000111100,
        0b1111111111111100,
        0b0000000000000000
    },
    {   // ASCII 077
        0b1111000000111100,
        0b1111110011111100,
        0b1111111111111100,
        0b1111111111111100,
        0b1111001100111100,
        0b1111000000111100,
        0b1111000000111100,
        0b0000000000000000
    },
    {   // ASCII 078
        0b1111000000111100,
        0b1111110000111100,
        0b1111111100111100,
        0b1111001111111100,
        0b1111000011111100,
        0b1111000000111100,
        0b1111000000111100,
        0b0000000000000000
    },
    {   // ASCII 079
        0b0000111111000000,
        0b0011110011110000,
        0b1111000000111100,
        0b1111000000111100,
        0b1111000000111100,
        0b0011110011110000,
        0b0000111111000000,
        0b0000000000000000
    },
    {   // ASCII 080
        0b1111111111110000,
        0b0011110000111100,
        0b0011110000111100,
        0b0011111111110000,
        0b0011110000000000,
        0b0011110000000000,
        0b1111111100000000,
        0b0000000000000000
    },
    {   // ASCII 081
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111001111110000,
        0b0011111111000000,
        0b0000001111110000,
        0b0000000000000000
    },
    {   // ASCII 082
        0b1111111111110000,
        0b0011110000111100,
        0b0011110000111100,
        0b0011111111110000,
        0b0011110011110000,
        0b0011110000111100,
        0b1111110000111100,
        0b0000000000000000
    },
    {   // ASCII 083
        0b0011111111000000,
        0b1111000011110000,
        0b0011110000000000,
        0b0000111100000000,
        0b0000001111000000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 084
        0b1111111111110000,
        0b1100111100110000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 085
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 086
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000111100000000,
        0b0000000000000000
    },
    {   // ASCII 087
        0b1111000000111100,
        0b1111000000111100,
        0b1111000000111100,
        0b1111001100111100,
        0b1111111111111100,
        0b1111110011111100,
        0b1111000000111100,
        0b0000000000000000
    },
    {   // ASCII 088
        0b1111000000111100,
        0b1111000000111100,
        0b0011110011110000,
        0b0000111111000000,
        0b0000111111000000,
        0b0011110011110000,
        0b1111000000111100,
        0b0000000000000000
    },
    {   // ASCII 089
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 090
        0b1111111111111100,
        0b1111000000111100,
        0b1100000011110000,
        0b0000001111000000,
        0b0000111100001100,
        0b0011110000111100,
        0b1111111111111100,
        0b0000000000000000
    },
    {   // ASCII 091
        0b0011111111000000,
        0b0011110000000000,
        0b0011110000000000,
        0b0011110000000000,
        0b0011110000000000,
        0b0011110000000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 092
        0b1111000000000000,
        0b0011110000000000,
        0b0000111100000000,
        0b0000001111000000,
        0b0000000011110000,
        0b0000000000111100,
        0b0000000000001100,
        0b0000000000000000
    },
    {   // ASCII 093
        0b0011111111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 094
        0b0000001100000000,
        0b0000111111000000,
        0b0011110011110000,
        0b1111000000111100,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 095
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111111
    },
    {   // ASCII 096
        0b0000111100000000,
        0b0000111100000000,
        0b0000001111000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 097
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111000000,
        0b0000000011110000,
        0b0011111111110000,
        0b1111000011110000,
        0b0011111100111100,
        0b0000000000000000
    },
    {   // ASCII 098
        0b1111110000000000,
        0b0011110000000000,
        0b0011110000000000,
        0b0011111111110000,
        0b0011110000111100,
        0b0011110000111100,
        0b1111001111110000,
        0b0000000000000000
    },
    {   // ASCII 099
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111000000000000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 100
        0b0000001111110000,
        0b0000000011110000,
        0b0000000011110000,
        0b0011111111110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111100111100,
        0b0000000000000000
    },
    {   // ASCII 101
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111111111110000,
        0b1111000000000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 102
        0b0000111111000000,
        0b0011110011110000,
        0b0011110000000000,
        0b1111111100000000,
        0b0011110000000000,
        0b0011110000000000,
        0b1111111100000000,
        0b0000000000000000
    },
    {   // ASCII 103
        0b0000000000000000,
        0b0000000000000000,
        0b0011111100111100,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111110000,
        0b0000000011110000,
        0b1111111111000000
    },
    {   // ASCII 104
        0b1111110000000000,
        0b0011110000000000,
        0b0011110011110000,
        0b0011111100111100,
        0b0011110000111100,
        0b0011110000111100,
        0b1111110000111100,
        0b0000000000000000
    },
    {   // ASCII 105
        0b0000111100000000,
        0b0000000000000000,
        0b0011111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 106
        0b0000000011110000,
        0b0000000000000000,
        0b0000000011110000,
        0b0000000011110000,
        0b0000000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000
    },
    {   // ASCII 107
        0b1111110000000000,
        0b0011110000000000,
        0b0011110000111100,
        0b0011110011110000,
        0b0011111111000000,
        0b0011110011110000,
        0b1111110000111100,
        0b0000000000000000
    },
    {   // ASCII 108
        0b0011111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 109
        0b0000000000000000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111111111111100,
        0b1111111111111100,
        0b1111001100111100,
        0b1111000000111100,
        0b0000000000000000
    },
    {   // ASCII 110
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0000000000000000
    },
    {   // ASCII 111
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 112
        0b0000000000000000,
        0b0000000000000000,
        0b1111001111110000,
        0b0011110000111100,
        0b0011110000111100,
        0b0011111111110000,
        0b0011110000000000,
        0b1111111100000000
    },
    {   // ASCII 113
        0b0000000000000000,
        0b0000000000000000,
        0b0011111100111100,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111110000,
        0b0000000011110000,
        0b0000001111111100
    },
    {   // ASCII 114
        0b0000000000000000,
        0b0000000000000000,
        0b1111001111110000,
        0b0011111100111100,
        0b0011110000111100,
        0b0011110000000000,
        0b1111111100000000,
        0b0000000000000000
    },
    {   // ASCII 115
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111110000,
        0b1111000000000000,
        0b0011111111000000,
        0b0000000011110000,
        0b1111111111000000,
        0b0000000000000000
    },
    {   // ASCII 116
        0b0000001100000000,
        0b0000111100000000,
        0b0011111111110000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100110000,
        0b0000001111000000,
        0b0000000000000000
    },
    {   // ASCII 117
        0b0000000000000000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111100111100,
        0b0000000000000000
    },
    {   // ASCII 118
        0b0000000000000000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000111100000000,
        0b0000000000000000
    },
    {   // ASCII 119
        0b0000000000000000,
        0b0000000000000000,
        0b1111000000111100,
        0b1111001100111100,
        0b1111111111111100,
        0b1111111111111100,
        0b0011110011110000,
        0b0000000000000000
    },
    {   // ASCII 120
        0b0000000000000000,
        0b0000000000000000,
        0b1111000000111100,
        0b0011110011110000,
        0b0000111111000000,
        0b0011110011110000,
        0b1111000000111100,
        0b0000000000000000
    },
    {   // ASCII 121
        0b0000000000000000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111110000,
        0b0000000011110000,
        0b1111111111000000
    },
    {   // ASCII 122
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111110000,
        0b1100001111000000,
        0b0000111100000000,
        0b0011110000110000,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 123
        0b0000001111110000,
        0b0000111100000000,
        0b0000111100000000,
        0b1111110000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000001111110000,
        0b0000000000000000
    },
    {   // ASCII 124
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000000000000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000000000000000
    },
    {   // ASCII 125
        0b1111110000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000001111110000,
        0b0000111100000000,
        0b0000111100000000,
        0b1111110000000000,
        0b0000000000000000
    },
    {   // ASCII 126
        0b0011111100111100,
        0b1111001111110000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 127
        0b0000000000000000,
        0b0000001100000000,
        0b0000111111000000,
        0b0011110011110000,
        0b1111000000111100,
        0b1111000000111100,
        0b1111111111111100,
        0b0000000000000000
    },
    {   // ASCII 128
        0b0011111111000000,
        0b1111000011110000,
        0b1111000000000000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000001111000000,
        0b0000000011110000,
        0b0011111111000000
    },
    {   // ASCII 129
        0b0000000000000000,
        0b1111000011110000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111111100,
        0b0000000000000000
    },
    {   // ASCII 130
        0b0000001111110000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111111111110000,
        0b1111000000000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 131
        0b0011111111111100,
        0b1111000000001111,
        0b0000111111110000,
        0b0000000000111100,
        0b0000111111111100,
        0b0011110000111100,
        0b0000111111111111,
        0b0000000000000000
    },
    {   // ASCII 132
        0b1111000011110000,
        0b0000000000000000,
        0b0011111111000000,
        0b0000000011110000,
        0b0011111111110000,
        0b1111000011110000,
        0b0011111111111100,
        0b0000000000000000
    },
    {   // ASCII 133
        0b1111110000000000,
        0b0000000000000000,
        0b0011111111000000,
        0b0000000011110000,
        0b0011111111110000,
        0b1111000011110000,
        0b0011111111111100,
        0b0000000000000000
    },
    {   // ASCII 134
        0b0000111100000000,
        0b0000111100000000,
        0b0011111111000000,
        0b0000000011110000,
        0b0011111111110000,
        0b1111000011110000,
        0b0011111111111100,
        0b0000000000000000
    },
    {   // ASCII 135
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000000000000,
        0b1111000000000000,
        0b0011111111000000,
        0b0000000011110000,
        0b0000111111000000
    },
    {   // ASCII 136
        0b0011111111111100,
        0b1111000000001111,
        0b0000111111110000,
        0b0011110000111100,
        0b0011111111111100,
        0b0011110000000000,
        0b0000111111110000,
        0b0000000000000000
    },
    {   // ASCII 137
        0b1111000011110000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111111111110000,
        0b1111000000000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 138
        0b1111110000000000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111111111110000,
        0b1111000000000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 139
        0b1111000011110000,
        0b0000000000000000,
        0b0011111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 140
        0b0011111111110000,
        0b1111000000111100,
        0b0000111111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000111111110000,
        0b0000000000000000
    },
    {   // ASCII 141
        0b1111110000000000,
        0b0000000000000000,
        0b0011111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 142
        0b1111000000111100,
        0b0000111111000000,
        0b0011110011110000,
        0b1111000000111100,
        0b1111111111111100,
        0b1111000000111100,
        0b1111000000111100,
        0b0000000000000000
    },
    {   // ASCII 143
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111111111110000,
        0b1111000011110000,
        0b0000000000000000
    },
    {   // ASCII 144
        0b0000001111110000,
        0b0000000000000000,
        0b1111111111110000,
        0b0011110000000000,
        0b0011111111000000,
        0b0011110000000000,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 145
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111111111,
        0b0000000011110000,
        0b0011111111111111,
        0b1111000011110000,
        0b0011111111111111,
        0b0000000000000000
    },
    {   // ASCII 146
        0b0000111111111100,
        0b0011110011110000,
        0b1111000011110000,
        0b1111111111111100,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011111100,
        0b0000000000000000
    },
    {   // ASCII 147
        0b0011111111000000,
        0b1111000011110000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 148
        0b0000000000000000,
        0b1111000011110000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 149
        0b0000000000000000,
        0b1111110000000000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 150
        0b0011111111000000,
        0b1111000011110000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111111100,
        0b0000000000000000
    },
    {   // ASCII 151
        0b0000000000000000,
        0b1111110000000000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111111100,
        0b0000000000000000
    },
    {   // ASCII 152
        0b0000000000000000,
        0b1111000011110000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111110000,
        0b0000000011110000,
        0b1111111111000000
    },
    {   // ASCII 153
        0b1111000000001111,
        0b0000001111000000,
        0b0000111111110000,
        0b0011110000111100,
        0b0011110000111100,
        0b0000111111110000,
        0b0000001111000000,
        0b0000000000000000
    },
    {   // ASCII 154
        0b1111000011110000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 155
        0b0000001111000000,
        0b0000001111000000,
        0b0011111111111100,
        0b1111000000000000,
        0b1111000000000000,
        0b0011111111111100,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 156
        0b0000111111000000,
        0b0011110011110000,
        0b0011110000110000,
        0b1111111100000000,
        0b0011110000000000,
        0b1111110000111100,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 157
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b1111111111110000,
        0b0000111100000000,
        0b1111111111110000,
        0b0000111100000000,
        0b0000111100000000
    },
    {   // ASCII 158
        0b1111111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111111111001100,
        0b1111000000111100,
        0b1111000011111111,
        0b1111000000111100,
        0b1111000000111111
    },
    {   // ASCII 159
        0b0000000011111100,
        0b0000001111001111,
        0b0000001111000000,
        0b0000111111110000,
        0b0000001111000000,
        0b0000001111000000,
        0b1111001111000000,
        0b0011111100000000
    },
    {   // ASCII 160
        0b0000001111110000,
        0b0000000000000000,
        0b0011111111000000,
        0b0000000011110000,
        0b0011111111110000,
        0b1111000011110000,
        0b0011111111111100,
        0b0000000000000000
    },
    {   // ASCII 161
        0b0000111111000000,
        0b0000000000000000,
        0b0011111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 162
        0b0000000000000000,
        0b0000001111110000,
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 163
        0b0000000000000000,
        0b0000001111110000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111111100,
        0b0000000000000000
    },
    {   // ASCII 164
        0b0000000000000000,
        0b1111111111000000,
        0b0000000000000000,
        0b1111111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0000000000000000
    },
    {   // ASCII 165
        0b1111111111110000,
        0b0000000000000000,
        0b1111000011110000,
        0b1111110011110000,
        0b1111111111110000,
        0b1111001111110000,
        0b1111000011110000,
        0b0000000000000000
    },
    {   // ASCII 166
        0b0000111111110000,
        0b0011110011110000,
        0b0011110011110000,
        0b0000111111111100,
        0b0000000000000000,
        0b0011111111111100,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 167
        0b0000111111000000,
        0b0011110011110000,
        0b0011110011110000,
        0b0000111111000000,
        0b0000000000000000,
        0b0011111111110000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 168
        0b0000111100000000,
        0b0000000000000000,
        0b0000111100000000,
        0b0011110000000000,
        0b1111000000000000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 169
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111110000,
        0b1111000000000000,
        0b1111000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 170
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000011110000,
        0b0000000011110000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 171
        0b1111000000001111,
        0b1111000000111100,
        0b1111000011110000,
        0b1111001111111100,
        0b0000111100001111,
        0b0011110000111100,
        0b1111000011110000,
        0b0000000011111111
    },
    {   // ASCII 172
        0b1111000000001111,
        0b1111000000111100,
        0b1111000011110000,
        0b1111001111001111,
        0b0000111100111111,
        0b0011110011111111,
        0b1111000011111111,
        0b0000000000001111
    },
    {   // ASCII 173
        0b0000001111000000,
        0b0000001111000000,
        0b0000000000000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000000000000000
    },
    {   // ASCII 174
        0b0000000000000000,
        0b0000111100001111,
        0b0011110000111100,
        0b1111000011110000,
        0b0011110000111100,
        0b0000111100001111,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 175
        0b0000000000000000,
        0b1111000011110000,
        0b0011110000111100,
        0b0000111100001111,
        0b0011110000111100,
        0b1111000011110000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 176
        0b0000110000001100,
        0b1100000011000000,
        0b0000110000001100,
        0b1100000011000000,
        0b0000110000001100,
        0b1100000011000000,
        0b0000110000001100,
        0b1100000011000000
    },
    {   // ASCII 177
        0b0011001100110011,
        0b1100110011001100,
        0b0011001100110011,
        0b1100110011001100,
        0b0011001100110011,
        0b1100110011001100,
        0b0011001100110011,
        0b1100110011001100
    },
    {   // ASCII 178
        0b1111001111001111,
        0b0011111100111111,
        0b1111001111001111,
        0b1111110011111100,
        0b1111001111001111,
        0b0011111100111111,
        0b1111001111001111,
        0b1111110011111100
    },
    {   // ASCII 179
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 180
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b1111111111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 181
        0b0000001111000000,
        0b0000001111000000,
        0b1111111111000000,
        0b0000001111000000,
        0b1111111111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 182
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b1111111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 183
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 184
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111000000,
        0b0000001111000000,
        0b1111111111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 185
        0b0000111100111100,
        0b0000111100111100,
        0b1111111100111100,
        0b0000000000111100,
        0b1111111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 186
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 187
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111100,
        0b0000000000111100,
        0b1111111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 188
        0b0000111100111100,
        0b0000111100111100,
        0b1111111100111100,
        0b0000000000111100,
        0b1111111111111100,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 189
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b1111111111111100,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 190
        0b0000001111000000,
        0b0000001111000000,
        0b1111111111000000,
        0b0000001111000000,
        0b1111111111000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 191
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 192
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 193
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b1111111111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 194
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111111,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 195
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111111111,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 196
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 197
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b1111111111111111,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 198
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111111111,
        0b0000001111000000,
        0b0000001111111111,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 199
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111111,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 200
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111111,
        0b0000111100000000,
        0b0000111111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 201
        0b0000000000000000,
        0b0000000000000000,
        0b0000111111111111,
        0b0000111100000000,
        0b0000111100111111,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 202
        0b0000111100111100,
        0b0000111100111100,
        0b1111111100111111,
        0b0000000000000000,
        0b1111111111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 203
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111111,
        0b0000000000000000,
        0b1111111100111111,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 204
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111111,
        0b0000111100000000,
        0b0000111100111111,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 205
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111111,
        0b0000000000000000,
        0b1111111111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 206
        0b0000111100111100,
        0b0000111100111100,
        0b1111111100111111,
        0b0000000000000000,
        0b1111111100111111,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 207
        0b0000001111000000,
        0b0000001111000000,
        0b1111111111111111,
        0b0000000000000000,
        0b1111111111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 208
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b1111111111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 209
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111111,
        0b0000000000000000,
        0b1111111111111111,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 210
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111111,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 211
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 212
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111111111,
        0b0000001111000000,
        0b0000001111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 213
        0b0000000000000000,
        0b0000000000000000,
        0b0000001111111111,
        0b0000001111000000,
        0b0000001111111111,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 214
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000111111111111,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 215
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100,
        0b1111111111111111,
        0b0000111100111100,
        0b0000111100111100,
        0b0000111100111100
    },
    {   // ASCII 216
        0b0000001111000000,
        0b0000001111000000,
        0b1111111111111111,
        0b0000001111000000,
        0b1111111111111111,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 217
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b1111111111000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 218
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000001111111111,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 219
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111
    },
    {   // ASCII 220
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111
    },
    {   // ASCII 221
        0b1111111100000000,
        0b1111111100000000,
        0b1111111100000000,
        0b1111111100000000,
        0b1111111100000000,
        0b1111111100000000,
        0b1111111100000000,
        0b1111111100000000
    },
    {   // ASCII 222
        0b0000000011111111,
        0b0000000011111111,
        0b0000000011111111,
        0b0000000011111111,
        0b0000000011111111,
        0b0000000011111111,
        0b0000000011111111,
        0b0000000011111111
    },
    {   // ASCII 223
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111,
        0b1111111111111111,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 224
        0b0000000000000000,
        0b0000000000000000,
        0b0011111100111100,
        0b1111001111110000,
        0b1111000011000000,
        0b1111001111110000,
        0b0011111100111100,
        0b0000000000000000
    },
    {   // ASCII 225
        0b0000000000000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111111111000000,
        0b1111000011110000,
        0b1111111111000000,
        0b1111000000000000,
        0b1111000000000000
    },
    {   // ASCII 226
        0b0000000000000000,
        0b1111111111110000,
        0b1111000011110000,
        0b1111000000000000,
        0b1111000000000000,
        0b1111000000000000,
        0b1111000000000000,
        0b0000000000000000
    },
    {   // ASCII 227
        0b0000000000000000,
        0b1111111111111100,
        0b0011110011110000,
        0b0011110011110000,
        0b0011110011110000,
        0b0011110011110000,
        0b0011110011110000,
        0b0000000000000000
    },
    {   // ASCII 228
        0b1111111111110000,
        0b1111000011110000,
        0b0011110000000000,
        0b0000111100000000,
        0b0011110000000000,
        0b1111000011110000,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 229
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111111100,
        0b1111001111000000,
        0b1111001111000000,
        0b1111001111000000,
        0b0011111100000000,
        0b0000000000000000
    },
    {   // ASCII 230
        0b0000000000000000,
        0b0011110000111100,
        0b0011110000111100,
        0b0011110000111100,
        0b0011110000111100,
        0b0011111111110000,
        0b0011110000000000,
        0b1111000000000000
    },
    {   // ASCII 231
        0b0000000000000000,
        0b0011111100111100,
        0b1111001111110000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000000000000000
    },
    {   // ASCII 232
        0b1111111111110000,
        0b0000111100000000,
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000111100000000,
        0b1111111111110000
    },
    {   // ASCII 233
        0b0000111111000000,
        0b0011110011110000,
        0b1111000000111100,
        0b1111111111111100,
        0b1111000000111100,
        0b0011110011110000,
        0b0000111111000000,
        0b0000000000000000
    },
    {   // ASCII 234
        0b0000111111000000,
        0b0011110011110000,
        0b1111000000111100,
        0b1111000000111100,
        0b0011110011110000,
        0b0011110011110000,
        0b1111110011111100,
        0b0000000000000000
    },
    {   // ASCII 235
        0b0000001111110000,
        0b0000111100000000,
        0b0000001111000000,
        0b0011111111110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0011111111000000,
        0b0000000000000000
    },
    {   // ASCII 236
        0b0000000000000000,
        0b0000000000000000,
        0b0011111111111100,
        0b1111001111001111,
        0b1111001111001111,
        0b0011111111111100,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 237
        0b0000000000111100,
        0b0000000011110000,
        0b0011111111111100,
        0b1111001111001111,
        0b1111001111001111,
        0b0011111111111100,
        0b0011110000000000,
        0b1111000000000000
    },
    {   // ASCII 238
        0b0000111111000000,
        0b0011110000000000,
        0b1111000000000000,
        0b1111111111000000,
        0b1111000000000000,
        0b0011110000000000,
        0b0000111111000000,
        0b0000000000000000
    },
    {   // ASCII 239
        0b0011111111000000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b1111000011110000,
        0b0000000000000000
    },
    {   // ASCII 240
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 241
        0b0000111100000000,
        0b0000111100000000,
        0b1111111111110000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 242
        0b0011110000000000,
        0b0000111100000000,
        0b0000001111000000,
        0b0000111100000000,
        0b0011110000000000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 243
        0b0000001111000000,
        0b0000111100000000,
        0b0011110000000000,
        0b0000111100000000,
        0b0000001111000000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000
    },
    {   // ASCII 244
        0b0000000011111100,
        0b0000001111001111,
        0b0000001111001111,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000
    },
    {   // ASCII 245
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000001111000000,
        0b1111001111000000,
        0b1111001111000000,
        0b0011111100000000
    },
    {   // ASCII 246
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000,
        0b1111111111110000,
        0b0000000000000000,
        0b0000111100000000,
        0b0000111100000000,
        0b0000000000000000
    },
    {   // ASCII 247
        0b0000000000000000,
        0b0011111100111100,
        0b1111001111110000,
        0b0000000000000000,
        0b0011111100111100,
        0b1111001111110000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 248
        0b0000111111000000,
        0b0011110011110000,
        0b0011110011110000,
        0b0000111111000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 249
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000001111000000,
        0b0000001111000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 250
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000001111000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 251
        0b0000000011111111,
        0b0000000011110000,
        0b0000000011110000,
        0b0000000011110000,
        0b1111110011110000,
        0b0011110011110000,
        0b0000111111110000,
        0b0000001111110000
    },
    {   // ASCII 252
        0b0011111111000000,
        0b0011110011110000,
        0b0011110011110000,
        0b0011110011110000,
        0b0011110011110000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 253
        0b0011111100000000,
        0b0000001111000000,
        0b0000111100000000,
        0b0011110000000000,
        0b0011111111000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 254
        0b0000000000000000,
        0b0000000000000000,
        0b0000111111110000,
        0b0000111111110000,
        0b0000111111110000,
        0b0000111111110000,
        0b0000000000000000,
        0b0000000000000000
    },
    {   // ASCII 255
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000,
        0b0000000000000000
    }
};

void drawCharacterOnScreen(byte ascii, byte x, byte y, byte backColor, byte foreColor, byte screen, byte firstPhysicalBlock)
{
    byte physicalBlock = firstPhysicalBlock;
    word address = 0x2000 + (word)y * 8 * 160 + x * 2;
    while(address >= 0x4000)
    {
        address -= 0x2000;
        physicalBlock++;
    }
    mapPhysicalToLogicalMemory(physicalBlock, _LOGICAL_2000_3FFF);

    for(byte index = 0; index <= 7; index++)
    {
        word pattern = codePage437[ascii][index];
        // Pattern    = 0b1111111111110000
        // foreMask   = 0b1110011110011110
        // foreground = 0b1110011110010000 = 32132100

        // Pattern    = 0b1111111111110000
        // foreMask   = 0b1001111001111001
        // foreground = 0b1001111001110000 = 21321300

        // Pattern    = 0b1111111111110000
        // foreMask   = 0b0111100111100111
        // foreground = 0b0111100111100000 = 13213200

        word foreMask = colorWordMasks[foreColor][index][screen];
        word backMask = colorWordMasks[backColor][index][screen];
        word foreground = pattern & foreMask;
        word background = ~pattern & backMask;
        word rasterWord = foreground | background;
        pokeWord(address, rasterWord);

        address += 160;
        if (address >= 0x4000)
        {
            address -= 0x2000;
            physicalBlock++;
            mapPhysicalToLogicalMemory(physicalBlock, _LOGICAL_2000_3FFF);
        }
    }
}

// public
void drawCharacter(byte ascii, byte x, byte y, byte backColor, byte foreColor, byte shouldBlink)
{
    byte foreColorAdjustedForBlink = shouldBlink ? backColor : foreColor;
    drawCharacterOnScreen(ascii, x, y, backColor, foreColorAdjustedForBlink, 0, _PHYSICAL_48000_49FFF);
    drawCharacterOnScreen(ascii, x, y, backColor, foreColor, 0, _PHYSICAL_50000_51FFF);
    drawCharacterOnScreen(ascii, x, y, backColor, foreColor, 1, _PHYSICAL_58000_59FFF);
    drawCharacterOnScreen(ascii, x, y, backColor, foreColor, 2, _PHYSICAL_60000_61FFF);
}
